<template lang="pug">

  .container(v-loading="pageLoading")
    .activity__block(v-if='updatedVacancy')
      p.create-date-lable Обновлено {{ updatedVacancy }}
    .block-typical

      el-form.flex-form(
        ref='vacancyForm'
        v-if="inputs.length"
        :model='stateForm'
        :rules="rules")

          el-form-item(
            v-for="item in inputs"
            :key="item.id"
            :style="vacancyFormStyle(item)"
            :prop="item.name")

            app-input(
              :placeholder="item.placeholder"
              :model="stateForm[item.name]"
              :name="item.name"
              :id="item.id"
              :label="item.label"
              :type="item.type"
              :prompt="item.prompt"
              :autosize="item.autosize"
              :maxlength="item.maxlength"
              :required="item.required"
              :submitFunc="updateVacancy"
              :formRef="'vacancyForm'"
              @input-value="modelValue")

    .activity__block.reverse
      .activity__block-wrapper
        h5 Активность:
        el-switch(
          v-model='vacancy.active'
          active-color="#39D24E"
          :active-value='true'
          :inactive-value='false')

    .activity__block
      router-link.el-button.el-button--info.button(
        :to="{path: '/admin/vacancies'}")
        |Отмена

      el-button.button(
        type="success"
        @click="updateVacancy('vacancyForm')")
        |Сохранить изменения

</template>

<script>
import InputItem from '../../../components/InputItem';

export default {
  layout: 'admin',
  name: 'VacanciesItem',
  components: {
    'app-input': InputItem
  },
  async asyncData(context) {
    let { data } = await context.$axios.get(
      `/api/v1/vacancies/${context.params.id}`
    );
    return { vacancy: data };
  },
  data() {
    return {
      readyToShip: false,
      dialogLoading: false,
      inputs: [
        {
          id: 0,
          placeholder: 'Укажите наименование вакансии',
          model: '',
          label: 'Наименование вакансии',
          name: 'name',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 1,
          placeholder: 'Укажите наименование вакансии',
          model: '',
          label: 'Географическое положение',
          name: 'city',
          prompt: 'Например: Кострома, АО "Шувалово"'
        },
        {
          id: 3,
          placeholder: 'Укажите описание новости',
          model: '',
          label: 'Описание новости',
          name: 'description',
          type: 'editor',
          required: true,
          minWidth: '100%',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 4,
          placeholder: '',
          model: '',
          label: 'Cортировка',
          name: 'sort',
          type: 'sort',
          required: true,
          maxWidth: '350px',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, укажите параметры сортировки',
              trigger: 'change'
            }
          ]
        },
        {
          id: 10,
          placeholder: '',
          model: '',
          label: 'Дата создания',
          name: 'created_at',
          type: 'datetime',
          maxWidth: '350px'
        }
      ],
      pageLoading: false,
      updatedVacancy: null
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        state[item.name] = this.vacancy[item.name];
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', [
      {
        name: 'Вакансии',
        slug: '/admin/vacancies'
      }
    ]);
    this.$store.commit('headingTitle', 'Вакансия');
    this.$store.commit('publicLink', `/about/vacancies/${this.vacancy.slug}`);
    this.$store.commit('id', this.vacancy.id);
  },
  mounted() {
    this.inputs.forEach(item => {
      item.model = this.vacancy[item.name];
    });
    if (this.vacancy.updated_at) {
      this.updatedVacancy = `${this.$moment(this.vacancy.updated_at).format(
        'D.MM.YY'
      )}, в ${this.$moment(this.vacancy.updated_at).format('H:mm')}`;
    }
  },
  methods: {
    vacancyFormStyle(item) {
      let style = {};
      if (item.maxWidth) {
        style['max-width'] = item.maxWidth;
      }
      if (item.minWidth) {
        style['min-width'] = item.minWidth;
      }
      style['margin-bottom'] = '35px';
      return style;
    },
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      this.vacancy[this.inputs[index].name] = valueArr[1];
    },
    updateVacancy(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.pageLoading = true;
          this.$axios
            .patch(`/api/v1/vacancies/${this.$route.params.id}`, {
              name: this.stateForm.name,
              description: this.stateForm.description,
              created_at: this.stateForm.created_at,
              city: this.stateForm.city,
              sort: this.stateForm.sort,
              active: this.vacancy.active
            })
            .then(
              () => {
                this.pageLoading = false;
                this.$message.success('Вакансия успешно изменена!');
              },
              errorMessage => {
                console.log(errorMessage);
                this.$message.error('Ошибка перезаписи данных!');
                this.pageLoading = false;
              }
            )
            .catch(() => {
              this.$message.error('Ошибка перезаписи данных');
              this.pageLoading = false;
            });
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
